"use strict";

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var readFile = require("read-file-cache"),
    tljs = require("template-literal"),
    typpy = require("typpy");

var BloggifyRenderer = function () {
    function BloggifyRenderer() {
        _classCallCheck(this, BloggifyRenderer);
    }

    _createClass(BloggifyRenderer, null, [{
        key: "init",
        value: function init(config) {
            Bloggify.renderer.registerRenderer("tljs", BloggifyRenderer.render);
        }
    }, {
        key: "factory",
        value: function factory(cb) {
            return function (ctx) {
                return cb(function (path, data, cb) {
                    return BloggifyRenderer.render(ctx, path, data, cb);
                }, ctx);
            };
        }
    }, {
        key: "render",
        value: function render(ctx, data, tmpl, cb) {
            var maybeCached = BloggifyRenderer.cache[tmpl.path];
            if (maybeCached) {
                data.statusCode = data.statusCode || data.error && data.error.statusCode || 200;

                var html = maybeCached(data);
                ctx.res.status(data.statusCode).end(html);
                return cb && cb(null, html);
            }

            readFile(tmpl.path, function (err, raw) {
                if (err) {
                    return cb && cb(err);
                }

                var templFn = BloggifyRenderer.cache[tmpl.path] = tljs(raw);
                data.statusCode = data.statusCode || data.error && data.error.statusCode || 200;

                var html = templFn(data);
                ctx.res.status(data.statusCode).end(html);
                cb && cb(null, html);
            });
        }
    }]);

    return BloggifyRenderer;
}();

BloggifyRenderer.cache = {};

module.exports = BloggifyRenderer;